//	GIF᡼
//	Version 0.10	2000.07.18
//	Version 0.11	2000.08.13
//
//	GIF Image Processing Class "GifImage"
//	Copyright (C) CONFLICT 2000.  All rights reserved.

import java.io.*;

/**
 *	GIF᡼뤿Υ饹Ǥ
 *	Ȥۤۻgifcat.pl򻲹ͤˤƤޤ
 *
 *	@author	դ꤯
 */
public class GifImage implements Cloneable {
	//	°
	private byte[] image;					//	ɤ߹GIF᡼
	
	//	GIF°
	private byte[]	signature;
	private byte[]	version;
	private int		logicalScreenWidth;
	private int		logicalScreenHeight;
	private int		packedFields18;
	private boolean	globalColorTableFlag;
	private int		colorResolution;
	private boolean	headerSortFlag;
	private int		sizeOfGlobalColorTable;
	private int		backgroundColorIndex;
	private int		pixelAspectRatio;
	private byte[]	globalColorTable;
	
	private int		imageSeparator;
	private int		imageLeftPosition;
	private int		imageTopPosition;
	private int		imageWidth;
	private int		imageHeight;
	private int		packedFields20;
	private boolean	localColorTableFlag;
	private boolean	interlaceFlag;
	private boolean	imageSortFlag;
	private int		reserved;
	private int		sizeOfLocalColorTable;
	private int		lzwMinimumCodeSize;
	private byte[]	imageData;
	
	private int		gceExtensionIntroducer;
	private int		graphicControlLabel;
	private int		gceBlockSize;
	private int		packedFields23;
	private int		disposalMethod;
	private boolean	userInputFlag;
	private boolean	transparentColorFlag;
	private int		delayTime;
	private int		transparentColorIndex;
	private int		blockTerminator;
	
	private int		ceExtensionIntroducer;
	private int		commentLabel;
	private byte[]	commentData;
	
	private int		pteExtensionIntroducer;
	private int		plainTextLabel;
	private int		pteBlockSize;
	private int		textGridLeftPosition;
	private int		textGridTopPosition;
	private int		textGridWidth;
	private int		textGridHeight;
	private int		characterCellWidth;
	private int		characterCellHeight;
	private int		textForegroundColorIndex;
	private int		textBackgroundColorIndex;
	private byte[]	textExtension;
	
	private int		aeExtensionIntroducer;
	private int		extentionLabel;
	private int		aeBlockSize;
	private byte[]	applicationIdentifire;
	private byte[]	applicationAuthenticationCode;
	private byte[]	applicationExtension;
	
	//	
	/**
	 *	᡼ˤޤ
	 *	parseImage()¹ԤƤɬפޤ
	 *	@return	ˡ
	 */
	public int getLogicalScreenWidth() {
		return logicalScreenWidth;
	}
	
	/**
	 *	᡼ʹ⤵ˤޤ
	 *	parseImage()¹ԤƤɬפޤ
	 *	@return	ʹ⤵ˡ
	 */
	public int getLogicalScreenHeight() {
		return logicalScreenHeight;
	}
	
	/**
	 *	᡼ΥХ륫顼ơ֥ե饰ޤ
	 *	parseImage()¹ԤƤɬפޤ
	 *	@return	Х륫顼ơ֥ե饰
	 */
	public boolean getGlobalColorTableFlag() {
		return globalColorTableFlag;
	}
	
	/**
	 *	᡼ΥХ륫顼ơ֥ޤ
	 *	parseImage()¹ԤƤɬפޤ
	 *	@return	Х륫顼ơ֥롣
	 */
	public byte[] getGlobalColorTable() {
		return globalColorTable;
	}
	
	/**
	 *	᡼PackedFields18ޤ
	 *	parseImage()¹ԤƤɬפޤ
	 *	@return	PackedFields18
	 */
	public int getPackedFields18() {
		return packedFields18;
	}
	
	/**
	 *	᡼طʿǥåޤ
	 *	parseImage()¹ԤƤɬפޤ
	 *	@return	طʿǥå
	 */
	public int getBackgroundColorIndex() {
		return backgroundColorIndex;
	}
	
	/**
	 *	᡼βǽĲޤ
	 *	parseImage()¹ԤƤɬפޤ
	 *	@return	ǽĲ档
	 */
	public int getPixelAspectRatio() {
		return pixelAspectRatio;
	}
	
	/**
	 *	᡼PackedFields23ޤ
	 *	parseImage()¹ԤƤɬפޤ
	 *	@return	PackedFields23
	 */
	public int getPackedFields23() {
		return packedFields23;
	}
	
	/**
	 *	᡼Ʃῧե饰ޤ
	 *	parseImage()¹ԤƤɬפޤ
	 *	@return	Ʃῧե饰
	 */
	public boolean getTransparentColorFlag() {
		return transparentColorFlag;
	}
	
	/**
	 *	᡼Ʃῧǥåޤ
	 *	parseImage()¹ԤƤɬפޤ
	 *	@return	Ʃῧǥå
	 */
	public int getTransparentColorIndex() {
		return transparentColorIndex;
	}
	
	/**
	 *	᡼ޤ
	 *	parseImage()¹ԤƤɬפޤ
	 *	@return	
	 */
	public int getImageWidth() {
		return imageWidth;
	}
	
	/**
	 *	᡼ι⤵ޤ
	 *	parseImage()¹ԤƤɬפޤ
	 *	@return	⤵
	 */
	public int getImageHeight() {
		return imageHeight;
	}
	
	/**
	 *	᡼PackedFields20ޤ
	 *	parseImage()¹ԤƤɬפޤ
	 *	@return	PackedFields20
	 */
	public int getPackedFields20() {
		return packedFields20;
	}
	
	/**
	 *	᡼LzwMinimumCodeSizeޤ
	 *	parseImage()¹ԤƤɬפޤ
	 *	@return	LzwMinimumCodeSize
	 */
	public int getLzwMinimumCodeSize() {
		return lzwMinimumCodeSize;
	}
	
	/**
	 *	GIF᡼Τ᡼ǡΤޤ
	 *	parseImage()¹ԤƤɬפޤ
	 *	@return	᡼ǡΡ
	 */
	public byte[] getImageData() {
		return imageData;
	}
	
	//	󥹥ȥ饯
	//	ե̾
	/**
	 *	ե̾ǻꤵ줿եɤ߹ߡGifImageۤޤ
	 *	@param	fln	ե̾
	 *	@throws	FileNotFoundException
	 *			ե뤬Ĥʤ硣
	 *	@throws	IOException
	 *			ϥ顼ȯ硣
	 */
	public GifImage(String fln) throws FileNotFoundException, IOException {
		loadFile(fln);
	}
	
	//	
	/**
	 *	ꤵ줿ǡ顢GifImageۤޤ
	 *	@param	array	GIF᡼
	 */
	public GifImage(byte[] array) {
		image = pickupBytes(array, 0, array.length);
	}
	
	//	ʣ᥽å
	/**
	 *	֥Ȥʣޤ
	 *	parseImage()η̤ϡʣޤ
	 *	@return	ʣ֥ȡ
	 */
	public Object clone() {
		return (Object)(new GifImage(image));
	}
	
	//	GIFեɤ߹
	/**
	 *	ե̾ǻꤵ줿ե뤫顢GIF᡼ɤ߹ߤޤ
	 *	@param	fln	ե̾
	 *	@throws	FileNotFoundException
	 *			ե뤬Ĥʤ硣
	 *	@throws	IOException
	 *			ϥ顼ȯ硣
	 */
	public void loadFile(String fln) throws FileNotFoundException, IOException 
	{
		//	μ
		File fh = new File(fln);
		int length = (int)fh.length();
		
		//	ǡɤ߹
		image = new byte[length];
		FileInputStream fis = new FileInputStream(fh);
		if(fis.read(image) != length)
			throw(new IOException());
		fis.close();
	}
	
	//	GIFեΤ֤
	/**
	 *	GIF᡼Τޤ
	 *	@return	GIF᡼
	 */
	public byte[] getImage() {
		return image;
	}
	
	//	GIFեΥ֤
	/**
	 *	GIF᡼ΤĹޤ
	 *	@return	GIF᡼Ĺ
	 */
	public int getImageSize() {
		return image.length;
	}
	
	//	GIFβ
	/**
	 *	GIF᡼ϤƼǡꤷޤ
	 *	@throws	Exception
	 *			ϥ顼ȯ硣
	 */
	public void parseImage() throws Exception {
		if(image.length <= 0)
			return;
		
		int index = parseHeader(0);
		while(true) {
			int x1 = (int)image[index] & 0xff;
			if(x1 == 0x2c) {
				index = parseImageBlock(index);
			}
			else if(x1 == 0x21) {
				int x2 = (int)image[index + 1] & 0xff;
				switch(x2) {
				case	0xf9:
					index = parseGraphicControlExtension(index);
					break;
				case	0xfe:
					index = parseCommentExtension(index);
					break;
				case	0x01:
					index = parsePlainTextExtension(index);
					break;
				case	0xff:
					index = parseApplicationExtension(index);
					break;
				default:
					throw(new Exception());
				}
			}
			else if(x1 == 0x3b) {
				index = parseTrailer(index);
				break;
			}
			else if(index >= image.length) {
				break;
			}
			else {
				throw(new Exception());
			}
		}
	}
	
	//	GIFإåβ
	private int parseHeader(int index) {
		signature				= pickupBytes(image, index, 3);		index += 3;
		version 				= pickupBytes(image, index, 3);		index += 3;
		logicalScreenWidth		= pack2ByteToInt(image, index);		index += 2;
		logicalScreenHeight		= pack2ByteToInt(image, index);		index += 2;
		
		packedFields18			= (int)image[index] & 0xff;			index++;
//		System.out.println("field18 " + packedFields18);
		globalColorTableFlag	= ((packedFields18 & 0x80) != 0);
		colorResolution			= ((packedFields18 & 0x70) >> 4) + 1;
		headerSortFlag			= ((packedFields18 & 0x08) != 0);
		sizeOfGlobalColorTable	= 1 << ((packedFields18 & 0x07) + 1);
		
		backgroundColorIndex	= (int)image[index] & 0xff;			index++;
		pixelAspectRatio		= (int)image[index] & 0xff;			index++;
		if(globalColorTableFlag) {
			globalColorTable = 
						pickupBytes(image, index, sizeOfGlobalColorTable * 3);
			index += sizeOfGlobalColorTable * 3;
		}
		
		return index;
	}
	
	//	᡼֥åβ
	private int parseImageBlock(int index) {
		imageSeparator			= (int)image[index] & 0xff;			index++;
		imageLeftPosition		= pack2ByteToInt(image, index);		index += 2;
		imageTopPosition		= pack2ByteToInt(image, index);		index += 2;
		imageWidth				= pack2ByteToInt(image, index);		index += 2;
		imageHeight				= pack2ByteToInt(image, index);		index += 2;
		
		packedFields20			= (int)image[index] & 0xff;			index++;
		localColorTableFlag		= ((packedFields20 & 0x80) != 0);
		interlaceFlag			= ((packedFields20 & 0x40) != 0);
		imageSortFlag			= ((packedFields20 & 0x20) != 0);
		reserved				= (packedFields20 & 0x18) >> 3;
		sizeOfLocalColorTable	= 1 << ((packedFields20 & 0x07) + 1);
		
		if(localColorTableFlag)
			index += sizeOfLocalColorTable * 3;
		
		lzwMinimumCodeSize		= (int)image[index] & 0xff;			index++;
		imageData 				= dataSubBlock(image, index);
		index += imageData.length;
		
		return index;
	}
	
	//	GraphicControlExtensionβ
	private int parseGraphicControlExtension(int index) {
		gceExtensionIntroducer	= (int)image[index] & 0xff;			index++;
		graphicControlLabel		= (int)image[index] & 0xff;			index++;
		gceBlockSize			= (int)image[index] & 0xff;			index++;
		
		packedFields23			= (int)image[index] & 0xff;			index++;
		reserved				= (packedFields23 & 0xe0) >> 5;
		disposalMethod			= (packedFields23 & 0x1c) >> 5;
		userInputFlag			= ((packedFields23 & 0x02) != 0);
		transparentColorFlag	= ((packedFields23 & 0x01) != 0);
		
		delayTime				= pack2ByteToInt(image, index);		index += 2;
		transparentColorIndex	= (int)image[index] & 0xff;			index++;
		blockTerminator			= (int)image[index] & 0xff;			index++;
		
		return index;
	}
	
	//	CommentExtensionβ
	private int parseCommentExtension(int index) {
		ceExtensionIntroducer	= (int)image[index] & 0xff;			index++;
		commentLabel			= (int)image[index] & 0xff;			index++;
		commentData				= dataSubBlock(image, index);
		index += commentData.length;
		
		return index;
	}
	
	//	PlainTextExtensionβ
	private int parsePlainTextExtension(int index) {
		pteExtensionIntroducer	= (int)image[index] & 0xff;			index++;
		plainTextLabel			= (int)image[index] & 0xff;			index++;
		pteBlockSize			= (int)image[index] & 0xff;			index++;
		textGridLeftPosition	= pack2ByteToInt(image, index);		index += 2;
		textGridTopPosition		= pack2ByteToInt(image, index);		index += 2;
		textGridWidth			= pack2ByteToInt(image, index);		index += 2;
		textGridHeight			= pack2ByteToInt(image, index);		index += 2;
		characterCellWidth		= (int)image[index] & 0xff;			index++;
		characterCellHeight		= (int)image[index] & 0xff;			index++;
		textForegroundColorIndex = (int)image[index] & 0xff;		index++;
		textBackgroundColorIndex = (int)image[index] & 0xff;		index++;
		textExtension			= dataSubBlock(image, index);
		index += textExtension.length;
		
		return index;
	}
	
	//	Application Extensionβ
	private int parseApplicationExtension(int index) {
		aeExtensionIntroducer	= (int)image[index] & 0xff;			index++;
		extentionLabel			= (int)image[index] & 0xff;			index++;
		aeBlockSize				= (int)image[index] & 0xff;			index++;
		applicationIdentifire	= pickupBytes(image, index, 8);		index += 8;
		applicationAuthenticationCode = pickupBytes(image, index, 3);
																	index += 3;
		applicationExtension	= dataSubBlock(image, index);
		index += applicationExtension.length;
		
		return index;
	}
	
	//	ȥ쥤顼β
	private int parseTrailer(int index) {
		index++;
		return index;
	}
	
	//	Data Sub Blockβ
	private byte[] dataSubBlock(byte[] image, int index) {
		int from = index;
		int len;
		
		while((len = (int)image[index] & 0xff) > 0) {
			index++;
			index += len;
		}
		index++;
		
		return pickupBytes(image, from, index - from);
	}
	
	//	byteڤФ
	private byte[] pickupBytes(byte[] src, int offset, int length) {
		byte[] dst = new byte[length];
		
		for(int i = 0; i < length; i++)
			dst[i] = src[offset + i];
		
		return dst;
	}
	
	//	2Ĥbyteͤintpack
	private int pack2ByteToInt(byte[] array, int o) {
		return ((int)array[o] & 0xff) | (((int)array[o+1] << 8) & 0xff00);
	}
}
